Index: moodle/lib/navigationlib.php
--- moodle/lib/navigationlib.php Base (1.86)
+++ moodle/lib/navigationlib.php Locally Modified (Based On 1.86)
@@ -1603,314 +1435,23 @@
                                 require_once($libfile);
                                 $reportfunction = $report.'_report_extend_navigation';
                                 if (function_exists($report.'_report_extend_navigation')) {
-                                    $reportfunction($reportnav, $course, $this->context);
+                        $reportfunction($reportnav, $course, $this->page->context);
                                 }
                             }
                         }
                     }
-                }
-            }
-
-            if (!$this->can_display_type(self::TYPE_SECTION)) {
-                if ($currentcourse!==false) {
-                    $currentcourse->nodetype = self::NODETYPE_LEAF;
-                }
                 return true;
             }
-        }
-    }
-    /**
-     * Loads the sections for a course
-     *
-     * @param array $keys By reference
-     * @param stdClass $course The course that we are loading sections for
-     */
-    protected function load_course_sections(&$keys, $course=null) {
-        global $PAGE, $CFG;
-        if ($course === null) {
-            $course = $PAGE->course;
-        }
-        $structurefile = $CFG->dirroot.'/course/format/'.$course->format.'/lib.php';
-        $structurefunc = 'callback_'.$course->format.'_load_content';
-        if (function_exists($structurefunc)) {
-            $structurefunc($this, $keys, $course);
-        } else if (file_exists($structurefile)) {
-            require_once $structurefile;
-            if (function_exists($structurefunc)) {
-                $structurefunc($this, $keys, $course);
-            } else {
-                $this->add_course_section_generic($keys, $course);
-            }
-        } else {
-            $this->add_course_section_generic($keys, $course);
-        }
-    }
-    /**
-     * This function loads the sections for a course if no given course format
-     * methods have been defined to do so. Thus generic
-     *
-     * @param array $keys By reference
-     * @param stdClass $course The course object to load for
-     * @param string $name String to use to describe the current section to the user
-     * @param string $activeparam Request variable to look for to determine the current section
-     * @return bool
-     */
-    public function add_course_section_generic(&$keys, $course=null, $name=null, $activeparam = null) {
-        global $PAGE;
 
-        if ($course === null) {
-            $course = $PAGE->course;
-        }
-
-        $coursesecstr = 'coursesections'.$course->id;
-        if (!$this->cache->cached($coursesecstr)) {
-            $sections = get_all_sections($course->id);
-            $this->cache->$coursesecstr = $sections;
-        } else {
-            $sections = $this->cache->$coursesecstr;
-        }
-
-        if (!$this->cache->compare('modinfo'.$course->id, $course->modinfo, false)) {
-            $this->cache->{'modinfo'.$course->id} = get_fast_modinfo($course);
-        }
-        $modinfo =  $this->cache->{'modinfo'.$course->id};
-
-        $depthforward = 0;
-        if (!is_array($modinfo->sections)) {
-            return $keys;
-        }
-
-        if ($name === null) {
-            $name = get_string('topic');
-        }
-
-        if ($activeparam === null) {
-            $activeparam = 'topic';
-        }
-
-        $coursenode = $this->find_child($course->id, navigation_node::TYPE_COURSE);
-        if ($coursenode!==false) {
-            $coursenode->action->param($activeparam,'0');
-        }
-
-        if (!$this->cache->cached('canviewhiddenactivities')) {
-            $this->cache->canviewhiddenactivities = has_capability('moodle/course:viewhiddenactivities', $this->context);
-        }
-        $viewhiddenactivities = $this->cache->canviewhiddenactivities;
-
-        if (!$this->cache->cached('canviewhiddensections')) {
-            $this->cache->canviewhiddensections = has_capability('moodle/course:viewhiddensections', $this->context);
-        }
-        $viewhiddensections = $this->cache->canviewhiddensections;
-
-        // MDL-20242 + MDL-21564
-        $sections = array_slice($sections, 0, $course->numsections+1, true);
-
-        foreach ($sections as $section) {
-            if ((!$viewhiddensections && !$section->visible) || (!$this->showemptybranches && !array_key_exists($section->section, $modinfo->sections))) {
-                continue;
-            }
-            if ($section->section!=0) {
-                $sectionkeys = $keys;
-                $url = new moodle_url('/course/view.php', array('id'=>$course->id, $activeparam=>$section->section));
-                $this->add_to_path($sectionkeys, $section->id, $name.' '.$section->section, null, navigation_node::TYPE_SECTION, $url);
-                $sectionchild = $this->find_child($section->id, navigation_node::TYPE_SECTION);
-                if ($sectionchild !== false) {
-                    $sectionchild->nodetype = self::NODETYPE_BRANCH;
-                    if ($sectionchild->isactive) {
-                        $this->load_section_activities($sectionkeys, $section->section);
-                    }
-                    if (!$section->visible) {
-                        $sectionchild->hidden = true;
-                    }
-                }
-            }
-        }
-        return true;
-    }
-
     /**
-     * Check if we are permitted to display a given type
-     *
-     * @return bool True if we are, False otherwise
+     * Clears the navigation cache
      */
-    protected function can_display_type($type) {
-        if (!is_null($this->expansionlimit) && $this->expansionlimit < $type) {
-            return false;
-        }
-        return true;
-    }
-
-    /**
-     * Loads the categories for the current course into the navigation structure
-     *
-     * @param array $keys Forced reference to and array to use for the keys
-     * @return int The number of categories
-     */
-    protected function load_course_categories(&$keys) {
-        global $PAGE;
-        $categories = $PAGE->categories;
-        if (is_array($categories) && count($categories)>0) {
-            $categories = array_reverse($categories);
-            foreach ($categories as $category) {
-                $key = $category->id.':'.self::TYPE_CATEGORY;
-                if (!$this->get_by_path(array_merge($keys, array($key)))) {
-                    $url = new moodle_url('/course/category.php', array('id'=>$category->id, 'categoryedit'=>'on', 'sesskey'=>sesskey()));
-                    $keys[] = $this->add_to_path($keys, $category->id, $category->name, $category->name, self::TYPE_CATEGORY, $url);
-                } else {
-                    $keys[] = $key;
-                }
-            }
-        }
-        return count($categories);
-    }
-
-    /**
-     * This is called by load_for_category to load categories into the navigation structure
-     *
-     * @param int $categoryid The specific category to load
-     * @return int The depth of categories that were loaded
-     */
-    protected function load_categories($categoryid=0) {
-        global $CFG, $DB, $USER;
-
-        if ($categoryid === 0 && $this->allcategoriesloaded) {
-            return 0;
-        }
-
-        $systemcontext = get_context_instance(CONTEXT_SYSTEM);
-
-        // If the user is logged in (but not as a guest), doesnt have the site config capability,
-        // and my courses havn't been disabled then we will show the user's courses in the
-        // global navigation, otherwise we will show up to FRONTPAGECOURSELIMIT available courses
-        if (isloggedin() && !is_siteadmin() && !isguestuser() && empty($CFG->disablemycourses)) {
-            if (!$this->cache->cached('mycourses')) {
-                $this->cache->mycourses = get_my_courses($USER->id);
-            }
-            $courses = $this->cache->mycourses;
-        } else {
-            // Check whether we have already cached the available courses
-            if (!$this->cache->cached('availablecourses')) {
-                // Non-cached - get accessinfo
-                if (isset($USER->access)) {
-                    $accessinfo = $USER->access;
-                } else {
-                    $accessinfo = get_user_access_sitewide($USER->id);
-                }
-                // Get the available courses using get_user_courses_bycap
-                $this->cache->availablecourses = get_user_courses_bycap($USER->id, 'moodle/course:participate',
-                                                                        $accessinfo, true, 'c.sortorder ASC',
-                                                                        array('fullname','visible', 'category'),
-                                                                        FRONTPAGECOURSELIMIT);
-            }
-            // Cache the available courses for a refresh
-            $courses = $this->cache->availablecourses;
-        }
-
-        // Iterate through all courses, and explode thier course category paths so that
-        // we can retrieve all of the individual category id's that are required
-        // to display the list of courses in the tree
-        $categoryids = array();
-        foreach ($courses as $course) {
-            // If a category id has been specified and the current course is not within
-            // that category or one of its children then skip this course
-            if ($categoryid!==0 && !preg_match('#/('.$categoryid.')(/|$)#', $course->categorypath)) {
-                continue;
-            }
-            $categorypathids = explode('/',trim($course->categorypath,' /'));
-            // If no category has been specified limit the depth we display immediatly to
-            // that of the nav var depthforwards
-            if ($categoryid===0 && count($categorypathids)>($this->depthforward+1) && empty($CFG->navshowallcourses)) {
-                $categorypathids = array_slice($categorypathids, 0, ($this->depthforward+1));
-            }
-            $categoryids = array_merge($categoryids, $categorypathids);
-        }
-        // Remove duplicate categories (and there will be a few)
-        $categoryids = array_unique($categoryids);
-
-        // Check whether we have some category ids to display and make sure that either
-        // no category has been specified ($categoryid===0) or that the category that
-        // has been specified is in the list.
-        if (count($categoryids)>0 && ($categoryid===0 || in_array($categoryid, $categoryids))) {
-            $catcachestr = 'categories'.join($categoryids);
-            if (!$this->cache->cached($catcachestr)) {
-                $this->cache->{$catcachestr} = $DB->get_records_select('course_categories', 'id IN ('.join(',', $categoryids).')', array(), 'path ASC, sortorder ASC');
-            }
-            $categories = $this->cache->{$catcachestr};
-            // Retrieve the nessecary categories and then proceed to add them to the tree
-            foreach ($categories as $category) {
-                $this->add_category_by_path($category);
-            }
-            // Add the courses that were retrieved earlier to the
-            $this->add_courses($courses);
-        } else if ($categoryid === 0) {
-            $keys = array();
-            $categories = $DB->get_records('course_categories', array('parent' => $categoryid), 'sortorder ASC');
-            $this->add_categories($keys, $categories);
-            $this->add_courses($courses, $categoryid);
-        }
-        $this->allcategoriesloaded = true;
-        return 0;
-    }
-
-    /**
-     * This function marks the cache as volatile so it is cleared during shutdown
-     */
     public function clear_cache() {
-        $this->cache->volatile();
+        $this->cache->clear();
     }
-
-    /**
-     * Finds all expandable nodes whilst ensuring that expansion limit is respected
-     *
-     * @param array $expandable A reference to an array that will be populated as
-     * we go.
-     */
-    public function find_expandable(&$expandable) {
-        parent::find_expandable($expandable, $this->expansionlimit);
     }
 
     /**
-     * Loads categories that contain no courses into the structure.
-     *
-     * These categories would normally be skipped, as such this function is purely
-     * for the benefit of code external to navigationlib
-     */
-    public function load_empty_categories() {
-        $categories = array();
-        $categorynames = array();
-        $categoryparents = array();
-        make_categories_list($categorynames, $categoryparents, '', 0, $category = NULL);
-        foreach ($categorynames as $id=>$name) {
-            if (!$this->find_child($id, self::TYPE_CATEGORY)) {
-                $category = new stdClass;
-                $category->id = $id;
-                if (array_key_exists($id, $categoryparents)) {
-                    $category->path = '/'.join('/',array_merge($categoryparents[$id],array($id)));
-                    $name = explode('/', $name);
-                    $category->name = join('/', array_splice($name, count($categoryparents[$id])));
-                } else {
-                    $category->path = '/'.$id;
-                    $category->name = $name;
-                }
-                $this->add_category_by_path($category);
-            }
-        }
-    }
-
-    public function collapse_course_categories() {
-        $categories = $this->get_children_by_type(self::TYPE_CATEGORY);
-        while (count($categories) > 0) {
-            foreach ($categories as $category) {
-                $this->children = array_merge($this->children, $category->children);
-                $this->remove_child($category->key, self::TYPE_CATEGORY);
-            }
-            $categories = $this->get_children_by_type(self::TYPE_CATEGORY);
-        }
-    }
-}
-
-/**
  * The limited global navigation class used for the AJAX extension of the global
  * navigation class.
  *
@@ -1927,20 +1468,33 @@
  * @license   http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
  */
 class global_navigation_for_ajax extends global_navigation {
+
+    /** @var array */
+    protected $expandable = array();
+
     /**
-     * Initialise the limited navigation object, calling it to auto generate
+     * Constructs the navigation for use in AJAX request
+     * @global stdClass $SITE
+     */
+    public function __construct() {
+        global $SITE;
+        $this->cache = new navigation_cache(NAVIGATION_CACHE_NAME);
+        $this->children = new navigation_node_collection();
+        $this->rootnodes = array();
+        //$this->rootnodes['site']      = $this->add_course($SITE);
+        $this->rootnodes['courses'] = $this->add(get_string('courses'), null, self::TYPE_ROOTNODE, null, 'courses');
+    }
+    /**
+     * Initialise the navigation given the type and id for the branch to expand.
      *
-     * This function can be used to initialise the global navigation object more
-     * flexibly by providing a couple of overrides.
-     * This is used when the global navigation is being generated without other fully
-     * initialised Moodle objects
-     *
-     * @param int $branchtype What to load for e.g. TYPE_SYSTEM
-     * @param int $id The instance id for what ever is being loaded
-     * @return array An array of nodes that are expandable by AJAX
+     * @global moodle_database $DB
+     * @global moodle_page $PAGE
+     * @param int $branchtype One of navigation_node::TYPE_*
+     * @param int $id
+     * @return array The expandable nodes
      */
     public function initialise($branchtype, $id) {
-        global $DB;
+        global $DB, $PAGE;
 
         if ($this->initialised || during_initial_install()) {
             return $this->expandable;
@@ -1948,264 +1502,56 @@
 
         // Branchtype will be one of navigation_node::TYPE_*
         switch ($branchtype) {
-            case self::TYPE_CATEGORY :
-                require_login();
-                $depth = $this->load_category($id);
-                break;
             case self::TYPE_COURSE :
                 $course = $DB->get_record('course', array('id' => $id), '*', MUST_EXIST);
                 require_course_login($course);
-                $depth = $this->load_course($id);
+                $this->page = $PAGE;
+                $coursenode = $this->add_course($course);
+                $this->add_course_essentials($coursenode, $course);
+                if ($this->format_display_course_content($course->format)) {
+                    $this->load_course_sections($course, $coursenode);
+                }
                 break;
             case self::TYPE_SECTION :
-                $sql = 'SELECT c.*
+                $sql = 'SELECT c.*, cs.section AS sectionnumber
                         FROM {course} c
                         LEFT JOIN {course_sections} cs ON cs.course = c.id
                         WHERE cs.id = ?';
                 $course = $DB->get_record_sql($sql, array($id), MUST_EXIST);
                 require_course_login($course);
-                $depth = $this->load_section($id);
+                $this->page = $PAGE;
+                $coursenode = $this->add_course($course);
+                $this->add_course_essentials($coursenode, $course);
+                $sections = $this->load_course_sections($course, $coursenode);
+                $this->load_section_activities($sections[$course->sectionnumber]->sectionnode, $course->sectionnumber, get_fast_modinfo($course));
                 break;
             case self::TYPE_ACTIVITY :
                 $cm = get_coursemodule_from_id(false, $id, 0, false, MUST_EXIST);
                 $course = $DB->get_record('course', array('id'=>$cm->course), '*', MUST_EXIST);
                 require_course_login($course, true, $cm);
-                $depth = $this->load_activity($id);
+                $this->page = $PAGE;
+                $coursenode = $this->load_course($course);
+                $sections = $this->load_course_sections($course, $coursenode);
+                foreach ($sections as $section) {
+                    if ($section->id == $cm->section) {
+                        $cm->sectionnumber = $section->section;
                 break;
+                    }
+                }
+                $activities = $this->load_section_activities($sections[$cm->sectionnumber]->sectionnode, $cm->sectionnumber, get_fast_modinfo($course));
+                $modulenode = $this->load_activity($cm, $course, $activities[$cm->id]);
+                break;
             default:
+                throw new Exception('Unknown type');
                 return $this->expandable;
-                break;
         }
 
-        $this->collapse_at_depth($this->depthforward+$depth);
-        $this->respect_forced_open();
-        $this->expandable = array();
         $this->find_expandable($this->expandable);
-        $this->initialised = true;
         return $this->expandable;
     }
-
-    /**
-     * Loads the content (sub categories and courses) for a given a category
-     *
-     * @param int $instanceid
-     */
-    protected function load_category($instanceid) {
-        if (!$this->cache->cached('coursecatcontext'.$instanceid)) {
-            $this->cache->{'coursecatcontext'.$instanceid} = get_context_instance(CONTEXT_COURSECAT, $instanceid);
         }
-        $this->context = $this->cache->{'coursecatcontext'.$instanceid};
-        $this->load_categories($instanceid);
-    }
 
     /**
-     * Use the instance id to load a course
-     *
-     * {@link global_navigation::load_course()}
-     * @param int $instanceid
-     */
-    protected function load_course($instanceid) {
-        global $DB, $PAGE;
-
-        if (!$this->cache->cached('course'.$instanceid)) {
-            if ($PAGE->course->id == $instanceid) {
-                $this->cache->{'course'.$instanceid} = $PAGE->course;
-            } else {
-                $this->cache->{'course'.$instanceid} = $DB->get_record('course', array('id'=>$instanceid), '*', MUST_EXIST);
-            }
-        }
-        $course = $this->cache->{'course'.$instanceid};
-
-        if (!$this->format_display_course_content($course->format)) {
-            return true;
-        }
-
-        if (!$this->cache->cached('coursecontext'.$course->id)) {
-            $this->cache->{'coursecontext'.$course->id} = get_context_instance(CONTEXT_COURSE, $course->id);
-        }
-        $this->context = $this->cache->{'coursecontext'.$course->id};
-
-        $keys = array();
-        parent::load_course($keys, $course);
-
-        if (isloggedin() && has_capability('moodle/course:participate', $this->context)) {
-            if (!$this->cache->cached('course'.$course->id.'section0')) {
-                $this->cache->{'course'.$course->id.'section0'} = get_course_section('0', $course->id);
-            }
-            $section = $this->cache->{'course'.$course->id.'section0'};
-            $this->load_section_activities($course, $section);
-            if ($this->depthforward>0) {
-                $this->load_course_sections($keys, $course);
-            }
-        }
-    }
-    /**
-     * Use the instance id to load a specific course section
-     *
-     * @param int $instanceid
-     */
-    protected function load_section($instanceid=0) {
-        global $DB, $PAGE, $CFG;
-
-        $section = $DB->get_record('course_sections', array('id'=>$instanceid), '*', MUST_EXIST);
-
-        if (!$this->cache->cached('course'.$section->course)) {
-            if ($PAGE->course->id == $section->course) {
-                $this->cache->{'course'.$section->course} = $PAGE->course;
-            } else {
-                $this->cache->{'course'.$section->course} = $DB->get_record('course', array('id'=>$section->course), '*', MUST_EXIST);
-            }
-        }
-        $course = $this->cache->{'course'.$section->course};
-
-        if (!$this->cache->cached('coursecontext'.$course->id)) {
-            $this->cache->{'coursecontext'.$course->id} = get_context_instance(CONTEXT_COURSE, $course->id);
-        }
-        $this->context = $this->cache->{'coursecontext'.$course->id};
-
-        // Call the function to generate course section
-        $keys = array();
-        $structurefile = $CFG->dirroot.'/course/format/'.$course->format.'/navigation_format.php';
-        $structurefunc = 'callback_'.$course->format.'_load_limited_section';
-        if (function_exists($structurefunc)) {
-            $sectionnode = $structurefunc($this, $keys, $course, $section);
-        } else if (file_exists($structurefile)) {
-            include $structurefile;
-            if (function_exists($structurefunc)) {
-                $sectionnode = $structurefunc($this, $keys, $course, $section);
-            } else {
-                $sectionnode = $this->limited_load_section_generic($keys, $course, $section);
-            }
-        } else {
-            $sectionnode = $this->limited_load_section_generic($keys, $course, $section);
-        }
-        if ($this->depthforward>0) {
-            $this->load_section_activities($course, $section);
-        }
-    }
-    /**
-     * This function is called if there is no specific course format function set
-     * up to load sections into the global navigation.
-     *
-     * Note that if you are writing a course format you can call this function from your
-     * callback function if you don't want to load anything special but just specify the
-     * GET argument that identifies the current section as well as the string that
-     * can be used to describve the section. e.g. weeks or topic
-     *
-     * @param array $keys
-     * @param stdClass $course
-     * @param stdClass $section
-     * @param string $name
-     * @param string $activeparam
-     * @return navigation_node|bool
-     */
-    public function limited_load_section_generic($keys, $course, $section, $name=null, $activeparam = 'topic') {
-        global $PAGE, $CFG;
-
-        if ($name === null) {
-            $name = get_string('topic');
-        }
-
-        if (!$this->cache->cached('canviewhiddensections')) {
-            $this->cache->canviewhiddensections = has_capability('moodle/course:viewhiddensections', $this->context);
-        }
-        $viewhiddensections = $this->cache->canviewhiddensections;
-
-        if (!$viewhiddensections && !$section->visible) {
-            return false;
-        }
-        if ($section->section!=0) {
-            $url = new moodle_url('/course/view.php', array('id'=>$course->id, $activeparam=>$section->id));
-            $keys[] = $this->add_to_path($keys, $section->id, $name.' '.$section->section, null, navigation_node::TYPE_SECTION, $url);
-            $sectionchild = $this->find_child($section->id, navigation_node::TYPE_SECTION);
-            if ($sectionchild !== false) {
-                $sectionchild->nodetype = self::NODETYPE_BRANCH;
-                $sectionchild->make_active();
-                if (!$section->visible) {
-                    $sectionchild->hidden = true;
-                }
-                return $sectionchild;
-            }
-        }
-        return false;
-    }
-
-    /**
-     * This function is used to load a course sections activities
-     *
-     * @param stdClass $course
-     * @param stdClass $section
-     * @return void
-     */
-    protected function load_section_activities($course, $section) {
-        global $CFG;
-        if (!is_object($section)) {
-            return;
-        }
-        if ($section->section=='0') {
-            $keys = array($section->course);
-        } else {
-            $keys = array($section->id);
-        }
-
-        $modinfo = get_fast_modinfo($course);
-
-        if (!$this->cache->cached('canviewhiddenactivities')) {
-            $this->cache->canviewhiddenactivities = has_capability('moodle/course:viewhiddenactivities', $this->context);
-        }
-        $viewhiddenactivities = $this->cache->canviewhiddenactivities;
-
-        foreach ($modinfo->cms as $module) {
-            if ((!$viewhiddenactivities && !$module->visible) || $module->sectionnum != $section->section) {
-                continue;
-            }
-            $icon = null;
-            if ($module->icon) {
-                $icon = new pix_icon($module->icon, '', $module->iconcomponent);
-            } else {
-                $icon = new pix_icon('icon', '', $module->modname);
-            }
-            $url = new moodle_url('/mod/'.$module->modname.'/view.php', array('id'=>$module->id));
-            $this->add_to_path($keys, $module->id, $module->name, $module->name, navigation_node::TYPE_ACTIVITY, $url, $icon);
-            $child = $this->find_child($module->id, navigation_node::TYPE_ACTIVITY);
-            if ($child != false) {
-                $child->title(get_string('modulename', $module->modname));
-                if (!$module->visible) {
-                    $child->hidden = true;
-                }
-                if ($this->module_extends_navigation($module->modname)) {
-                    $child->nodetype = self::NODETYPE_BRANCH;
-                }
-            }
-        }
-    }
-
-    /**
-     * This function loads any navigation items that might exist for an activity
-     * by looking for and calling a function within the modules lib.php
-     *
-     * @param int $instanceid
-     * @return void
-     */
-    protected function load_activity($instanceid) {
-        global $CFG, $PAGE;
-
-        $this->context = get_context_instance(CONTEXT_COURSE, $PAGE->course->id);
-        $key = $this->add($PAGE->activityname, null, self::TYPE_ACTIVITY, null, $instanceid);
-
-        $file = $CFG->dirroot.'/mod/'.$PAGE->activityname.'/lib.php';
-        $function = $PAGE->activityname.'_extend_navigation';
-
-        if (file_exists($file)) {
-            require_once($file);
-            if (function_exists($function)) {
-                $function($this->get($key), $PAGE->course, $PAGE->activityrecord, $PAGE->cm);
-            }
-        }
-    }
-}
-
-/**
  * Navbar class
  *
  * This class is used to manage the navbar, which is initialised from the navigation
@@ -2223,7 +1569,7 @@
     protected $keys = array();
     /** @var null|string */
     protected $content = null;
-    /** @var page object */
+    /** @var moodle_page object */
     protected $page;
     /** @var bool */
     protected $ignoreactive = false;
@@ -2231,11 +1577,16 @@
     protected $duringinstall = false;
     /** @var bool */
     protected $hasitems = false;
-
+    /** @var array */
+    protected $items;
+    /** @var array */
+    public $children = array();
     /**
      * The almighty constructor
+     *
+     * @param moodle_page $page
      */
-    public function __construct(&$page) {
+    public function __construct(moodle_page $page) {
         global $CFG;
         if (during_initial_install()) {
             $this->duringinstall = true;
